| Liveness Engine SDK Liveness detection engine.

Classes | Enumerations | Functions
Liveness detection.

Public interfaces for various liveness detection algorithms, related types and structures. More...

## Classes
struct | lsdk::Angles
| Structure for angle measurements retrieval. More...
struct | lsdk::Scores
| Structure for score measurements retrieval. More...
struct | lsdk::EyeStates
| Structure for eyeStates retrieval. More...
struct | lsdk::ILiveness
| Liveness detector interface. More...
struct | lsdk::IUnifiedLiveness
| Unified liveness detector interface. This liveness type includes previous types and performs all calculation in one session. It performs tracking of value of type used on the creation stage, besides it also tracks remaining measurements in order to identify fraud attempt. More...
struct | lsdk::IComplexLiveness
| Complex liveness detector interface. More...
struct | lsdk::ILivenessEngine
| Root Liveness SDK object interface. More...

## Enumerations
enum | lsdk::LivenessAlgorithmType { lsdk::LA_PITCH_DOWN, lsdk::LA_PITCH_UP, lsdk::LA_YAW_LEFT, lsdk::LA_YAW_RIGHT, lsdk::LA_SMILE, lsdk::LA_MOUTH, lsdk::LA_EYEBROW, lsdk::LA_EYE, lsdk::LA_FLOW, lsdk::LA_INFRARED, lsdk::LA_COUNT }
| Simple liveness algorithm type enumeration. More...
enum | lsdk::ComplexLivenessAlgorithmType { lsdk::CLA_DEPTH, lsdk::CLA_COUNT }
| Complex liveness algorithm type enumeration. More...
enum | lsdk::LSDKError : uint32_t { lsdk::LSDKError::Ok, lsdk::LSDKError::NotInitialized, lsdk::LSDKError::NotReady, lsdk::LSDKError::PreconditionFailed, lsdk::LSDKError::Internal }

## Functions
template<typename T , typename... Args>
uint32_t | lsdk::field (T current, Args... rest) noexcept
| Auxiliary function for binary field composition. More...
template<typename T >
uint32_t | lsdk::field (T last) noexcept
FSDK_API fsdk::ResultValue< fsdk::FSDKError, lsdk::ILivenessEnginePtr > | lsdk::createLivenessEngine (fsdk::Ref< fsdk::IFaceEngine > FaceEngine, const char *path=nullptr) noexcept
| Create the Liveness SDK root object. More...

## Detailed Description

Public interfaces for various liveness detection algorithms, related types and structures.

## Enumeration Type Documentation

## ◆ ComplexLivenessAlgorithmType

enum lsdk::ComplexLivenessAlgorithmType

Complex liveness algorithm type enumeration.

Enumerator
CLA_DEPTH | Algorithm based on depth map analysis.
CLA_COUNT | Not a type; counts number of available types.

## ◆ LivenessAlgorithmType

enum lsdk::LivenessAlgorithmType

Simple liveness algorithm type enumeration.

Enumerator
LA_PITCH_DOWN | Algorithm based on upward face movement.
LA_PITCH_UP | Algorithm based on downward face movement.
LA_YAW_LEFT | Algorithm based on leftward face movement.
LA_YAW_RIGHT | Algorithm based on rightward face movement.
LA_SMILE | Algorithm based on smile.
LA_MOUTH | Algorithm based on mouth opening.
LA_EYEBROW | Algorithm based on eyebrows rising.
LA_EYE | Algorithm based on eye blinking.
LA_FLOW | Algorithm based on camera zooming.
LA_INFRARED | ALgorithm based on infrared warp analisys.
LA_COUNT | Not a type; counts number of available types.

## ◆ LSDKError

enum lsdk::LSDKError : uint32_t
| strong

Enumerator
Ok | Ok.
NotInitialized | Liveness not initialized.
NotReady | Liveness not ready, require more updates.
PreconditionFailed | Starting condition is not accomplished, liveness not started yet.
Internal | Internal error.

## Function Documentation

## ◆ createLivenessEngine()

FSDK_API fsdk::ResultValue<fsdk::FSDKError, lsdk::ILivenessEnginePtr> lsdk::createLivenessEngine | ( | fsdk::Ref< fsdk::IFaceEngine > | FaceEngine,
|  | const char * | path = `nullptr`
| ) |  |
| noexcept

Create the Liveness SDK root object.

Parameters

  [in] | FaceEngine | [optional] Face Engine object;

See also
  FaceEngineSDK.

Parameters

  [in] | path | [optional] Path to data folder with configuration file;

Note
  If no FaceEngine object passed, LivenessEngine internally creates its own.

Returns
  liveness engine object if succeeded, nullptr if failed.

## ◆ field()

template<typename T , typename... Args>

uint32_t lsdk::field | ( | T | current,
|  | Args... | rest
| ) |  |
| noexcept

Auxiliary function for binary field composition.

Note
  Use: feild(LA_SMILE, LA_MOUTH, ... , LA_YAW_RIGHT);